## CongCommandHistory

CongCommandHistory —

## Synopsis

    #define     DEBUG_COMMAND_HISTORY_LIFETIMES
    struct      CongCommandHistory;
    #define     CONG_COMMAND_HISTORY            (obj)
    #define     CONG_COMMAND_HISTORY_CLASS      (klass)
    #define     IS_CONG_COMMAND_HISTORY         (obj)
    GType       cong_command_history_get_type   (void);
    CongCommandHistory* cong_command_history_construct
                                                (CongCommandHistory *command_history);
    CongCommandHistory* cong_command_history_new
                                                (void);
    void        cong_command_history_add_command
                                                (CongCommandHistory *command_history,
                                                 CongCommand *command);
    gboolean    cong_command_history_can_undo   (CongCommandHistory *command_history);
    gboolean    cong_command_history_can_redo   (CongCommandHistory *command_history);
    void        cong_command_history_undo       (CongCommandHistory *command_history);
    void        cong_command_history_redo       (CongCommandHistory *command_history);
    CongCommand* cong_command_history_get_next_undo_command
                                                (CongCommandHistory *command_history);
    CongCommand* cong_command_history_get_next_redo_command
                                                (CongCommandHistory *command_history);

## Object Hierarchy

      GObject
       +----CongCommandHistory

## Signal Prototypes

    "changed"   void        user_function      (CongCommandHistory *congcommandhistory,
                                                gpointer user_data);

## Description

## Details

### DEBUG_COMMAND_HISTORY_LIFETIMES

    #define DEBUG_COMMAND_HISTORY_LIFETIMES 0

### struct CongCommandHistory

    struct CongCommandHistory;

### CONG_COMMAND_HISTORY()

    #define CONG_COMMAND_HISTORY(obj)         G_TYPE_CHECK_INSTANCE_CAST (obj, CONG_COMMAND_HISTORY_TYPE, CongCommandHistory)

`obj` : |

### CONG_COMMAND_HISTORY_CLASS()

    #define CONG_COMMAND_HISTORY_CLASS(klass) G_TYPE_CHECK_CLASS_CAST (klass, CONG_COMMAND_HISTORY_TYPE, CongCommandHistoryClass)

`klass` : |

### IS_CONG_COMMAND_HISTORY()

    #define IS_CONG_COMMAND_HISTORY(obj)      G_TYPE_CHECK_INSTANCE_TYPE (obj, CONG_COMMAND_HISTORY_TYPE)

`obj` : |

### cong_command_history_get_type ()

    GType       cong_command_history_get_type   (void);

Returns : |

### cong_command_history_construct ()

    CongCommandHistory* cong_command_history_construct
                                                (CongCommandHistory *command_history);

TODO: Write me

`command_history` : |
Returns : |

### cong_command_history_new ()

    CongCommandHistory* cong_command_history_new
                                                (void);

TODO: Write me

Returns : |

### cong_command_history_add_command ()

    void        cong_command_history_add_command
                                                (CongCommandHistory *command_history,
                                                 CongCommand *command);

TODO: Write me

`command_history` : |
`command` : |

### cong_command_history_can_undo ()

    gboolean    cong_command_history_can_undo   (CongCommandHistory *command_history);

TODO: Write me

`command_history` : |
Returns : |

### cong_command_history_can_redo ()

    gboolean    cong_command_history_can_redo   (CongCommandHistory *command_history);

TODO: Write me

`command_history` : |
Returns : |

### cong_command_history_undo ()

    void        cong_command_history_undo       (CongCommandHistory *command_history);

TODO: Write me

`command_history` : |

### cong_command_history_redo ()

    void        cong_command_history_redo       (CongCommandHistory *command_history);

TODO: Write me

`command_history` : |

### cong_command_history_get_next_undo_command ()

    CongCommand* cong_command_history_get_next_undo_command
                                                (CongCommandHistory *command_history);

TODO: Write me

`command_history` : |
Returns : |

### cong_command_history_get_next_redo_command ()

    CongCommand* cong_command_history_get_next_redo_command
                                                (CongCommandHistory *command_history);

TODO: Write me

`command_history` : |
Returns : |

## Signals

### The "changed" signal

    void        user_function                  (CongCommandHistory *congcommandhistory,
                                                gpointer user_data);

`congcommandhistory` : | the object which received the signal.
`user_data` : | user data set when the signal handler was connected.